#include "yaml_data.hpp"
#include <sstream>

// For DTMB BEGO MAHDB (YAML by Antoine PAGES)

std::string test_data::bug_3235()
{
    std::stringstream ss;
    ss << "rotations convention: [psi, theta', phi'']\n"
       << "\n"
       << "environmental constants:\n"
       << "    g: {value: 9.81, unit: m/s^2}\n"
       << "    rho: {value: 1000, unit: kg/m^3}\n"
       << "    nu: {value: 1.14e-6, unit: m^2/s}\n"
       << "\n"
       << "# Fixed frame: NED\n"
       << "bodies: # All bodies have NED as parent frame\n"
       << "  - name: dtmb\n"
       << "    position of body frame relative to mesh:\n"
       << "        frame: mesh\n"
       << "        x: {value: 1.375, unit: m}\n"
       << "        y: {value: 0, unit: m}\n"
       << "        z: {value: -0.148, unit: m}\n"
       << "        phi: {value: 0, unit: rad}\n"
       << "        theta: {value: 0, unit: rad}\n"
       << "        psi: {value: 0, unit: rad}\n"
       << "    dynamics:\n"
       << "        hydrodynamic forces calculation point in body frame:\n"
       << "            x: {value: 0, unit: m}\n"
       << "            y: {value: 0, unit: m}\n"
       << "            z: {value: 0.068, unit: m}\n"
       << "        centre of inertia:\n"
       << "            frame: dtmb\n"
       << "            x: {value: 0, unit: m}\n"
       << "            y: {value: 0, unit: m}\n"
       << "            z: {value: 0, unit: m} \n"
       << "        rigid body inertia matrix at the center of gravity and projected in the body frame:\n"
       << "            row 1: [63.5,0,0,0,0,0]\n"
       << "            row 2: [0,63.5,0,0,0,0]\n"
       << "            row 3: [0,0,63.5,0,0,0]\n"
       << "            row 4: [0,0,0,1.028,0,0]\n"
       << "            row 5: [0,0,0,0,30.76,0]\n"
       << "            row 6: [0,0,0,0,0,30.76]\n"
       << "        added mass matrix at the center of gravity and projected in the body frame:\n"
       << "            from hdb: dtmb_bego.HDB\n"
       << "    mesh: dtmb_bego.stl\n"
       << "    initial position of body frame relative to NED:\n"
       << "        frame: NED\n"
       << "        x: {value: 0, unit: m}\n"
       << "        y: {value: 0, unit: m}\n"
       << "        z: {value: -0.0270, unit: m}\n"
       << "        phi: {value: 0, unit: deg}\n"
       << "        theta: {value: 0.02, unit: deg}\n"
       << "        psi: {value: 0, unit: deg}\n"
       << "    initial velocity of body frame relative to NED:\n"
       << "        frame: dtmb\n"
       << "        u: {value: 0, unit: m/s}\n"
       << "        v: {value: 0, unit: m/s}\n"
       << "        w: {value: 0, unit: m/s}\n"
       << "        p: {value: 0, unit: rad/s}\n"
       << "        q: {value: 0, unit: rad/s}\n"
       << "        r: {value: 0, unit: rad/s}\n"
       << "    external forces:\n"
       << "      - model: gravity\n"
       << "      - model: non-linear hydrostatic (exact)\n"
       << "      - model: linear damping\n"
       << "        damping matrix at the center of gravity projected in the body frame:\n"
       << "            row 1: [ 0, 0,      0,      0,       0, 0]\n"
       << "            row 2: [ 0, 0,      0,      0,       0, 0]\n"
       << "            row 3: [ 0, 0, 4.68e2,      0,       0, 0]\n"
       << "            row 4: [ 0, 0,      0, 1.24e-1,       0, 0]\n"
       << "            row 5: [ 0, 0,      0,      0, 2.06e2, 0]\n"
       << "            row 6: [ 0, 0,      0,      0,       0, 0]\n"
       << "      - model: quadratic damping\n"
       << "        damping matrix at the center of gravity projected in the body frame:\n"
       << "            row 1: [ 0, 0, 0,      0, 0, 0]\n"
       << "            row 2: [ 0, 0, 0,      0, 0, 0]\n"
       << "            row 3: [ 0, 0, 0,      0, 0, 0]\n"
       << "            row 4: [ 0, 0, 0, 1.27e-1, 0, 0]\n"
       << "            row 5: [ 0, 0, 0,      0, 0, 0]\n"
       << "            row 6: [ 0, 0, 0,      0, 0, 0]\n"
       << "environment models:\n"
       << "  - model: no waves\n"
       << "    constant sea elevation in NED frame: {value: 0, unit: m}\n";
    return ss.str();
}
